function Fig7
clc
close all
clear all

error = 1e-8;
d = 2;  % Dimension
MM = 1000;
for c = 1:(MM-1)
    maxl = 1;
    minl = 1-(c/MM);
    l(c,:) = [minl,(rand(1,(d-2))*(maxl-minl))+minl,maxl];
    e(c) = (maxl-minl)/(maxl+minl);
end
[es,si] = sort(e);
ls = l(si,:);

for c = 1:(MM-1)
    Lo(c) = finde(error, ls(c,:));
end
set(gcf, 'Color', [1 1 1])
Figure1=figure(1);
set(Figure1,'defaulttextinterpreter','latex');
plot(es,smooth(Lo, 5, 'moving'),'LineWidth', 2)
hold on
% pause
clear l e si
error = 1e-8;
d = 50;  % Dimension
MM = 1000;
for c = 1:(MM-1)
    maxl = 1;
    minl = 1-(c/MM);
    l(c,:) = [minl,(rand(1,(d-2))*(maxl-minl))+minl,maxl];
    e(c) = (maxl-minl)/(maxl+minl);
end
[es,si] = sort(e);
ls = l(si,:);

for c = 1:(MM-1)
    Lo(c) = finde(error, ls(c,:));
end
plot(es,smooth(Lo, 25, 'moving'),'r','LineWidth', 2)

clear l e si
error = 1e-8;
d = 120;  % Dimension
MM = 1000;
for c = 1:(MM-1)
    maxl = 1;
    minl = 1-(c/MM);
    l(c,:) = [minl,(rand(1,(d-2))*(maxl-minl))+minl,maxl];
    e(c) = (maxl-minl)/(maxl+minl);
end
[es,si] = sort(e);
ls = l(si,:);

for c = 1:(MM-1)
    Lo(c) = finde(error, ls(c,:));
end
plot(es,smooth(Lo, 25, 'moving'),'g','LineWidth', 2)

clear l e si
error = 1e-8;
d = 250;  % Dimension
MM = 1000;
for c = 1:(MM-1)
    maxl = 1;
    minl = 1-(c/MM);
    l(c,:) = [minl,(rand(1,(d-2))*(maxl-minl))+minl,maxl];
    e(c) = (maxl-minl)/(maxl+minl);
end
[es,si] = sort(e);
ls = l(si,:);

for c = 1:(MM-1)
    Lo(c) = finde(error, ls(c,:));
end
plot(es,smooth(Lo, 25, 'moving'),'y','LineWidth', 2)
set(gca, 'XTick', [0,0.2,0.4,0.6,0.8,1])
set(gca, 'YTick', [0,1000,2000,3000,4000])
ylabel('Average Needed Flops')
xlabel('$\epsilon$')
h = legend('$d = 2$','$d = 50$','$d = 120$','$d = 250$','location','NorthWest');
set(h,'Interpreter','latex')
axis([0 1 0 4000])