function A = Fast_Methods(mat, Num)

d = length(mat);

switch Num
    % First Fast Method
    case 1
        A = psi(d/2)+log(2*trace(mat)/d);
    % Second Fast Method
    case 2
        tr = trace(mat);
        m2 = mat.';
        tr2 = m2(:).' * mat(:); % faster version sum(sum(mat.*mat'))
        A = psi((tr^2)/(2*tr2)) + log((2*tr2)/tr);
    % Third Fast Method
    case 3
        tr = trace(mat);
        m2 = mat.';
        tr2 = m2(:).' * mat(:); % faster version sum(sum(mat.*mat'))
        A = (psi(d/2)+log(2*tr/d)) * 0.3 + (psi((tr^2)/(2*tr2)) + log((2*tr2)/tr)) * 0.7;
end
end