function A = NumInt(l, delta, dof, d)

fun = @(x) inint(x, l, delta, dof, d);
cons = quadgk(fun,0,Inf,'RelTol',1e-9,'AbsTol',1e-13);
% cons = quadgk(fun,0,Inf);
A = psi(d/2)+log(2*sum(l)/d)+cons;
end

function y = inint(x, l, delta, dof, d)
% Function for value inside integral
im = 1;
for j = 1:d
    im = im .* exp((-delta(j)*l(j)*x)./(1+2*l(j).*x)).*((1+2*l(j).*x).^(-dof(j)/2));
end

y = (1./x).*(((1+(2*x*sum(l)/d)).^(-d/2))-im);
end